Index: /extensions/Register_FluxBB/admin/admin.php
===================================================================
--- /extensions/Register_FluxBB/admin/admin.php	(revision 21423)
+++ /extensions/Register_FluxBB/admin/admin.php	(revision 21424)
@@ -1,46 +1,21 @@
 <?php
 
-global $user, $lang, $conf, $template, $errors;
+global $page, $user, $lang, $conf, $template, $errors;
 
 if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
 
-if (!defined('REGFLUXBB_PATH')) define('REGFLUXBB_PATH' , PHPWG_PLUGINS_PATH.basename(dirname(__FILE__)).'/');
-
-ini_set('error_reporting', E_ALL);
-ini_set('display_errors', true);
+check_status(ACCESS_ADMINISTRATOR);
+
+if(!defined('REGFLUXBB_PATH'))
+{
+  define('REGFLUXBB_PATH' , PHPWG_PLUGINS_PATH.basename(dirname(__FILE__)).'/');
+}
 
 include_once (PHPWG_ROOT_PATH.'admin/include/tabsheet.class.php');
 include_once (PHPWG_ROOT_PATH.'/include/constants.php');
 
-$my_base_url = get_admin_plugin_menu_link(__FILE__);
 load_language('plugin.lang', REGFLUXBB_PATH);
 
-// +-----------------------------------------------------------------------+
-// |                            Tabssheet                                  |
-// +-----------------------------------------------------------------------+
-if (!isset($_GET['tab']))
-  $page['tab'] = 'info';
-else
-  $page['tab'] = $_GET['tab'];
-
-$tabsheet = new tabsheet();
-$tabsheet->add('info',
-            l10n('Tab_Info'),
-            $my_base_url.'&amp;tab=info');
-$tabsheet->add('manage',
-            l10n('Tab_Manage'),
-            $my_base_url.'&amp;tab=manage');
-$tabsheet->add('Migration',
-            l10n('Tab_Migration'),
-            $my_base_url.'&amp;tab=Migration');
-$tabsheet->add('Synchro',
-            l10n('Tab_Synchro'),
-            $my_base_url.'&amp;tab=Synchro');
-$tabsheet->select($page['tab']);
-$tabsheet->assign();
-
-
-$page['infos'] = array();
-$error = array();
+$conf_Register_FluxBB = unserialize($conf['Register_FluxBB']);
 
 // +-----------------------------------------------------------------------+
@@ -51,16 +26,283 @@
 
 // +-----------------------------------------------------------------------+
-// |                            Functions
+// |                            Actions process                            |
 // +-----------------------------------------------------------------------+
-function Audit_PWG_FluxBB()
-{
-  global $page, $conf, $errors;
-
-  $conf_Register_FluxBB = isset($conf['Register_FluxBB']) ? explode(";" , $conf['Register_FluxBB']) : array();
-
+if (isset($_GET['action']) and ($_GET['action']=='link_dead'))
+{
+  $query = '
+DELETE FROM '.Register_FluxBB_ID_TABLE.'
+WHERE id_user_FluxBB NOT IN (
+  SELECT id
+  FROM '.FluxBB_USERS_TABLE.'
+  )
+OR id_user_pwg NOT IN (
+  SELECT id
+  FROM '.USERS_TABLE.'
+  )
+;';
+
+  $result = pwg_query($query);
+  
+  Audit_PWG_FluxBB();
+}
+else if (isset($_GET['action']) and ($_GET['action']=='link_del') and isset($_GET['pwg_id']) and isset($_GET['bb_id']))
+{
+  $query = '
+DELETE FROM '.Register_FluxBB_ID_TABLE.'
+WHERE id_user_pwg = '.$_GET['pwg_id'].'
+AND id_user_FluxBB = '.$_GET['bb_id'].'
+;';
+
+  $result = pwg_query($query);
+  
+  Audit_PWG_FluxBB();
+}
+else if (isset($_GET['action']) and ($_GET['action']=='new_link') and isset($_GET['pwg_id']) and isset($_GET['bb_id']))
+{
+  FluxBB_Linkuser($_GET['pwg_id'], $_GET['bb_id']);
+  
+  Audit_PWG_FluxBB();
+}
+else if (isset($_GET['action']) and ($_GET['action']=='sync_user') and isset($_GET['username']))
+{
+  $query = '
+SELECT id AS id_pwg, username, password, mail_address 
+FROM '.USERS_TABLE.'
+WHERE BINARY username = BINARY "'.pwg_db_real_escape_string($_GET['username']).'"
+AND username NOT IN ("18","16")
+LIMIT 1
+;';
+
+  $data = pwg_db_fetch_assoc(pwg_query($query));
+  
+  if (!empty($data))
+  {
+    FluxBB_Updateuser($data['id_pwg'], stripslashes($data['username']), $data['password'], $data['mail_address']);
+  }
+  
+  Audit_PWG_FluxBB();
+}
+else if (isset($_GET['action']) and ($_GET['action']=='add_user') and isset($_GET['username']))
+{
+  $query = '
+SELECT id, username, password, mail_address 
+FROM '.USERS_TABLE.'
+WHERE BINARY username = BINARY "'.pwg_db_real_escape_string($_GET['username']).'"
+AND username NOT IN ("18","16")
+LIMIT 1
+;';
+
+  $data = pwg_db_fetch_assoc(pwg_query($query));
+  
+  if (!empty($data))
+    FluxBB_Adduser($data['id'], stripslashes($data['username']), $data['password'], $data['mail_address']);  
+  
+    Audit_PWG_FluxBB();
+}
+else if (isset($_GET['action']) and ($_GET['action']=='del_user') and isset($_GET['id']))
+{
+  FluxBB_Deluser( $_GET['id'], true );
+  
+  Audit_PWG_FluxBB();
+}
+
+
+// +------------------------------------------------------------------+
+// |                        Plugin settings                           |
+// +------------------------------------------------------------------+
+if (isset($_POST['submit']) and isset($_POST['FluxBB_prefix']) and isset($_POST['FluxBB_admin']) and isset($_POST['FluxBB_guest']) and isset($_POST['FluxBB_del_pt']) and isset($_POST['FluxBB_confirm']) and isset($_POST['FluxBB_details']))
+{
+  $_POST['FluxBB_admin'] = stripslashes($_POST['FluxBB_admin']);
+  $_POST['FluxBB_guest'] = stripslashes($_POST['FluxBB_guest']);
+
+/* Configuration controls */
+// Piwigo's admin username control
+  $query = '
+SELECT username, id
+FROM '.USERS_TABLE.'
+WHERE id = '.$conf['webmaster_id'].'
+;';
+
+  $pwgadmin = pwg_db_fetch_assoc(pwg_query($query));
+
+// FluxBB's admin username control
+  $query = '
+SELECT username, id
+FROM '.FluxBB_USERS_TABLE.'
+WHERE id = 2
+;';
+
+  $fbbadmin = pwg_db_fetch_assoc(pwg_query($query));
+
+// FluxBB's Guest username control
+  $query = '
+SELECT username, id
+FROM '.FluxBB_USERS_TABLE.'
+WHERE id = 1
+;';
+
+  $fbbguest = pwg_db_fetch_assoc(pwg_query($query));
+
+// Compute configuration errors
+  if (stripslashes($pwgadmin['username']) != $_POST['FluxBB_admin'])
+  {
+    array_push($page['errors'], l10n('error_config_admin1'));
+  }
+  if (stripslashes($pwgadmin['username']) != stripslashes($fbbadmin['username']))
+  {
+    array_push($page['errors'], l10n('error_config_admin2'));
+  }
+  if (stripslashes($fbbguest['username']) != stripslashes($_POST['FluxBB_guest']))
+  {
+    array_push($page['errors'], l10n('error_config_guest'));
+  }
+  elseif (count($page['errors']) == 0)
+  {
+    if (!function_exists('FindAvailableConfirmMailID'))
+    {
+      $_POST['FluxBB_UAM'] = 'false';
+      $_POST['FluxBB_group'] = '0';
+
+      $newconf_RegFluxBB['REGFLUXBB_VERSION'] = $version;
+      $newconf_RegFluxBB['FLUXBB_PREFIX'] = (isset($_POST['FluxBB_prefix']) ? $_POST['FluxBB_prefix'] : '');
+      $newconf_RegFluxBB['FLUXBB_ADMIN'] = (isset($_POST['FluxBB_admin']) ? $_POST['FluxBB_admin'] : '');
+      $newconf_RegFluxBB['FLUXBB_GUEST'] = (isset($_POST['FluxBB_guest']) ? $_POST['FluxBB_guest'] : '');
+      $newconf_RegFluxBB['FLUXBB_DEL_PT'] = (isset($_POST['FluxBB_del_pt']) ? $_POST['FluxBB_del_pt'] : 'false');
+      $newconf_RegFluxBB['FLUXBB_CONFIRM'] = (isset($_POST['FluxBB_confirm']) ? $_POST['FluxBB_confirm'] : 'false');
+      $newconf_RegFluxBB['FLUXBB_DETAIL'] = (isset($_POST['FluxBB_details']) ? $_POST['FluxBB_details'] : 'false');
+      $newconf_RegFluxBB['FLUXBB_UAM_LINK'] = (isset($_POST['FluxBB_UAM']) ? $_POST['FluxBB_UAM'] : 'false');
+      $newconf_RegFluxBB['FLUXBB_GROUP'] = (isset($_POST['FluxBB_group']) ? $_POST['FluxBB_group'] : '');
+    }
+    elseif (function_exists('FindAvailableConfirmMailID'))
+    {
+      $conf_UAM = unserialize($conf['UserAdvManager']);
+        
+      if (isset($conf_UAM['CONFIRM_MAIL']) and ($conf_UAM['CONFIRM_MAIL'] == 'true' or $conf_UAM['CONFIRM_MAIL'] == 'local') and isset($conf_UAM['NO_CONFIRM_GROUP']) and $conf_UAM['NO_CONFIRM_GROUP'] != '-1')
+      {
+        $newconf_RegFluxBB['REGFLUXBB_VERSION'] = $version;
+        $newconf_RegFluxBB['FLUXBB_PREFIX'] = (isset($_POST['FluxBB_prefix']) ? $_POST['FluxBB_prefix'] : '');
+        $newconf_RegFluxBB['FLUXBB_ADMIN'] = (isset($_POST['FluxBB_admin']) ? $_POST['FluxBB_admin'] : '');
+        $newconf_RegFluxBB['FLUXBB_GUEST'] = (isset($_POST['FluxBB_guest']) ? $_POST['FluxBB_guest'] : '');
+        $newconf_RegFluxBB['FLUXBB_DEL_PT'] = (isset($_POST['FluxBB_del_pt']) ? $_POST['FluxBB_del_pt'] : 'false');
+        $newconf_RegFluxBB['FLUXBB_CONFIRM'] = (isset($_POST['FluxBB_confirm']) ? $_POST['FluxBB_confirm'] : 'false');
+        $newconf_RegFluxBB['FLUXBB_DETAIL'] = (isset($_POST['FluxBB_details']) ? $_POST['FluxBB_details'] : 'false');
+        $newconf_RegFluxBB['FLUXBB_UAM_LINK'] = (isset($_POST['FluxBB_UAM']) ? $_POST['FluxBB_UAM'] : 'false');
+        $newconf_RegFluxBB['FLUXBB_GROUP'] = (isset($_POST['FluxBB_group']) ? $_POST['FluxBB_group'] : '');
+      }
+      else
+      {
+        $_POST['FluxBB_UAM'] = 'false';
+        $_POST['FluxBB_group'] = '0';
+
+        $newconf_RegFluxBB['REGFLUXBB_VERSION'] = $version;
+        $newconf_RegFluxBB['FLUXBB_PREFIX'] = (isset($_POST['FluxBB_prefix']) ? $_POST['FluxBB_prefix'] : '');
+        $newconf_RegFluxBB['FLUXBB_ADMIN'] = (isset($_POST['FluxBB_admin']) ? $_POST['FluxBB_admin'] : '');
+        $newconf_RegFluxBB['FLUXBB_GUEST'] = (isset($_POST['FluxBB_guest']) ? $_POST['FluxBB_guest'] : '');
+        $newconf_RegFluxBB['FLUXBB_DEL_PT'] = (isset($_POST['FluxBB_del_pt']) ? $_POST['FluxBB_del_pt'] : 'false');
+        $newconf_RegFluxBB['FLUXBB_CONFIRM'] = (isset($_POST['FluxBB_confirm']) ? $_POST['FluxBB_confirm'] : 'false');
+        $newconf_RegFluxBB['FLUXBB_DETAIL'] = (isset($_POST['FluxBB_details']) ? $_POST['FluxBB_details'] : 'false');
+        $newconf_RegFluxBB['FLUXBB_UAM_LINK'] = (isset($_POST['FluxBB_UAM']) ? $_POST['FluxBB_UAM'] : 'false');
+        $newconf_RegFluxBB['FLUXBB_GROUP'] = (isset($_POST['FluxBB_group']) ? $_POST['FluxBB_group'] : '');
+      }
+    }
+
+    $conf['Register_FluxBB'] = serialize($newconf_RegFluxBB);
+
+    conf_update_param('Register_FluxBB', pwg_db_real_escape_string($conf['Register_FluxBB']));
+
+    array_push($page['infos'], l10n('save_config'));
+  }
+}
+
+
+// +------------------------------------------------------------+
+// |                    Migration and Audit                     |
+// +------------------------------------------------------------+
+if (isset($_POST['Migration']))
+{
+  array_push($page['infos'], l10n('Mig_Start').'<br><br>');
+
+  array_push($page['infos'], l10n('Mig_Del_Link').'<br><br>');
+
+  $query = 'TRUNCATE '.Register_FluxBB_ID_TABLE.';';
+  $result = pwg_query($query);
+
+  $msg_Mig_Del_AllUsers = '';
+
+  $query = '
+SELECT username, id
+FROM '.FluxBB_USERS_TABLE.'
+;';
+
+  $result = pwg_query($query);
+
+  while ($row = pwg_db_fetch_assoc($result))
+  {
+    if((stripslashes($row['username']) != stripslashes($conf_Register_FluxBB['FLUXBB_GUEST'])) and (stripslashes($row['username']) != stripslashes($conf_Register_FluxBB['FLUXBB_ADMIN'])))
+    {
+      $msg_Mig_Del_AllUsers .= '<br> - '.l10n('Mig_Del_User').stripslashes($row['username']);
+
+      FluxBB_Deluser($row['id'], false);
+    }
+  }
+
+  array_push($page['infos'], l10n('Mig_Del_AllUsers').$msg_Mig_Del_AllUsers.'<br><br>');
+
+  $query = '
+SELECT id, username, password, mail_address
+FROM '.USERS_TABLE.'
+WHERE username NOT IN ("18","16")
+;';
+
+  $result = pwg_query($query);
+
+  $registred = time();
+  $registred_ip = $_SERVER['REMOTE_ADDR'];
+
+  $msg_Mig_Add_AllUsers = '';
+
+  while ($row = pwg_db_fetch_assoc($result))
+  {
+    if((stripslashes($row['username']) != 'guest') and (stripslashes($row['username']) != stripslashes($conf_Register_FluxBB['FLUXBB_ADMIN'])))
+    {
+      $msg_Mig_Add_AllUsers .= '<br> - '.l10n('Mig_Add_User').stripslashes($row['username']);
+
+      FluxBB_Adduser($row['id'], stripslashes($row['username']), $row['password'], $row['mail_address']);
+    }
+  }
+
+  array_push($page['infos'], l10n('Mig_Add_AllUsers').$msg_Mig_Add_AllUsers.'<br><br>');
+
+  $query = '
+SELECT id, username, password, mail_address
+FROM '.USERS_TABLE.'
+WHERE username = "'.$conf_Register_FluxBB['FLUXBB_ADMIN'].'"
+AND username NOT IN ("18","16")
+;';
+
+  $row = pwg_db_fetch_assoc(pwg_query($query));
+
+  if (!empty($row))
+  {
+    array_push($page['infos'], l10n('Sync_User').stripslashes($row['username']).'<br><br>');
+
+    FluxBB_Updateuser($row['id'], stripslashes($row['username']), $row['password'], $row['mail_address']);
+  }
+
+  array_push($page['infos'], l10n('Mig_End'));
+}
+else if (isset($_POST['Audit']))
+{
+  Audit_PWG_FluxBB();
+}
+
+
+// +--------------------------------------------------------+
+// |                    Synch and Audit                     |
+// +--------------------------------------------------------+
+if ( isset($_POST['Synchro']))
+{
   $page_Register_FluxBB_admin = get_admin_plugin_menu_link(__FILE__);
   
-
-
   $msg_error_PWG_Dup = '';
   $msg_error_FluxBB_Dup = '';
